// O(n * (log(n) * log(Lmax))
// Lmax = 1e9
#include <fstream>
#include <algorithm>
#include <cassert>
using namespace std;

ifstream fin("2d.in");
ofstream fout("2d.out");

const int MAXN = 200100;

char S[100];
int A[MAXN];
int N, K, i, Sol, Poz, sign;

inline bool Check(int Rez);

int main()
{
	fin >> N >> K;
	double x, y;
	for (i = 1; i <= N; ++i){
		
		fin >> x >> y;
	
		A[i] = x * 1000;
	}

	sort(A + 1, A + N + 1); // O(n * log(N))

	int Left = 1000, Right = 2e9, Mid, Lmin = 1000;
	
	while (Left <= Right) // O(n * log(Lmax))         Lmax = 2e9
	{
		Mid = (Left + Right) / 2;
		if (Check(Mid))
		{
			Lmin = Mid;
			Right = Mid - 1;
		}
		else
			Left = Mid + 1;
	}

	fout <<  Lmin / 1000 << '.' <<  Lmin % 1000;

	return 0;
}

k = 3
L = 2
  |   |   |   | |     |
1 2 3 4 5 6 7 8 9 10 11 12
  *   *   *     *        *
                    last



inline bool Check(int L) // O(n)
{
	int Last = -2e9;
	int Nr = 0;

	for (int i = 1; i <= N; ++i)
	{
		if (A[i] <= Last)
			continue;
		Last = A[i] + L;
		++Nr;
		if (Nr > K) return false;
	}
	return true;
}
