// O((Q + n)*log(n))
#include <iostream>
#include <algorithm>
using namespace std;

// 1 5 5 5 5 5 6 7 9 
// x = 5

const int Dim = 200001;
int a[Dim], n;
int Q;      // numarul de query-uri (de intrebari)

// returneaza pozitia celei mai mici valoari >=x
int Bs1(int x); 

// returneaza pozitia celei mai mari valoari <= y
int Bs2(int y); 


int main()
{
	int x, y;
	cin >> n >> Q;

	for (int i = 1; i <= n; ++i)
		cin >> a[i];
		
	sort(a + 1, a + n + 1); // O(n * log2(n))
	
	int p1 = -1, p2 = -1;
	
	while (Q--)           // O(Q * log(n))
	{
		cin >> x >> y;
		
		p1 = Bs1(x);
		p2 = Bs2(y);
		
		if (p1 == -1 || p2 == -1)
			cout << 0 << '\n';
		else
			cout << p2 - p1 + 1 << '\n';
	}
}

int Bs2(int y)
{
	if (y < a[1]) return -1;
	int poz = -1;
	int st = 1, dr = n, m;
	
	while (st <= dr)
	{
		m = (st + dr) / 2;
		
		if (a[m] <= y)
		{
			poz = m;
			st = m + 1;
		}
		else
			dr = m - 1;
	}
	
	return poz;
}

int Bs1(int x)
{
	int poz = -1;
	if (x > a[n]) return poz;
	
	int st = 1, dr = n, m;
	
	while (st <= dr)
	{
		m = (st + dr) / 2;
		
		if (a[m] >= x)
		{
			poz = m;
			dr = m - 1;
		}
		else
			st = m + 1;
	}
	
	return poz;
}








